#include <imsls.h>
#include <stdlib.h>
#include <stdio.h>

int main()
{
  int i;
  int maxlag = 10;
  int nobs = 144;
  int n_differences = 2;
  int n_s_initial = 2;
  int nlost;
  int npar;
  float aic;
  int s_init[] = { 1, 1,
                   1, 12};
  int *s = NULL;
  int *d = NULL;
  float *z = NULL;
  float *difference = NULL;
  
  z = imsls_f_data_sets(4, 0);
  
  difference = imsls_f_seasonal_fit(nobs, z, maxlag, n_differences,
                                    n_s_initial, s_init,
                                    IMSLS_LOST, &nlost,
                                    IMSLS_BEST_PERIODS, &s,
                                    IMSLS_BEST_ORDERS, &d,
                                    IMSLS_AIC, &aic,
                                    IMSLS_AR_ORDER, &npar,
                                    0);
                                       
  printf("\nnlost = %d\n", nlost);
  printf("s = (%d, %d)\n", s[0], s[1]);
  printf("d = (%d, %d)\n", d[0], d[1]);
  printf("Order of optimum AR process: %d\n", npar);
  printf("aic = %lf\n", aic);

  printf("\ni\tz[i]\tdifference[i]\n");
  for (i=0; i<nobs; i++)
    printf("%d\t%f\t%f\n", i, z[i], difference[i]);
                                        
  if (s)
  {
     imsls_free(s);
     s = NULL;
  }
  
  if (d)
  {
     imsls_free(d);
     d = NULL;
  }
  
  if (z)
  {
     imsls_free(z);
     z = NULL;
  }
  
  if (difference)
  {
     imsls_free(difference);
     difference = NULL; 
  }
  
  return;
}
